(function (_, kotlin_kotlin) {
  'use strict';
  //region block: imports
  var protoOf = kotlin_kotlin.$_$.ed;
  var classMeta = kotlin_kotlin.$_$.qb;
  var setMetadataFor = kotlin_kotlin.$_$.fd;
  var Unit_instance = kotlin_kotlin.$_$.m5;
  var Enum = kotlin_kotlin.$_$.fi;
  var Collection = kotlin_kotlin.$_$.p5;
  var isInterface = kotlin_kotlin.$_$.mc;
  var VOID = kotlin_kotlin.$_$.f;
  var objectMeta = kotlin_kotlin.$_$.dd;
  var emptyList = kotlin_kotlin.$_$.n7;
  var objectCreate = kotlin_kotlin.$_$.cd;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.l;
  var AbstractList = kotlin_kotlin.$_$.n5;
  var THROW_CCE = kotlin_kotlin.$_$.si;
  //endregion
  //region block: pre-declaration
  setMetadataFor(Antilog, 'Antilog', classMeta);
  setMetadataFor(LogLevel, 'LogLevel', classMeta, Enum);
  setMetadataFor(Napier, 'Napier', objectMeta);
  setMetadataFor(AtomicMutableList, 'AtomicMutableList', classMeta, AbstractList, VOID, AtomicMutableList_init_$Create$);
  setMetadataFor(AtomicRef, 'AtomicRef', classMeta);
  //endregion
  function Antilog() {
  }
  protoOf(Antilog).u5e = function (priority, tag) {
    return true;
  };
  protoOf(Antilog).v5e = function (priority, tag, throwable, message) {
    this.w5e(priority, tag, throwable, message);
  };
  var LogLevel_VERBOSE_instance;
  var LogLevel_DEBUG_instance;
  var LogLevel_INFO_instance;
  var LogLevel_WARNING_instance;
  var LogLevel_ERROR_instance;
  var LogLevel_ASSERT_instance;
  var LogLevel_entriesInitialized;
  function LogLevel_initEntries() {
    if (LogLevel_entriesInitialized)
      return Unit_instance;
    LogLevel_entriesInitialized = true;
    LogLevel_VERBOSE_instance = new LogLevel('VERBOSE', 0);
    LogLevel_DEBUG_instance = new LogLevel('DEBUG', 1);
    LogLevel_INFO_instance = new LogLevel('INFO', 2);
    LogLevel_WARNING_instance = new LogLevel('WARNING', 3);
    LogLevel_ERROR_instance = new LogLevel('ERROR', 4);
    LogLevel_ASSERT_instance = new LogLevel('ASSERT', 5);
  }
  function LogLevel(name, ordinal) {
    Enum.call(this, name, ordinal);
  }
  function LogLevel_VERBOSE_getInstance() {
    LogLevel_initEntries();
    return LogLevel_VERBOSE_instance;
  }
  function LogLevel_DEBUG_getInstance() {
    LogLevel_initEntries();
    return LogLevel_DEBUG_instance;
  }
  function LogLevel_INFO_getInstance() {
    LogLevel_initEntries();
    return LogLevel_INFO_instance;
  }
  function LogLevel_WARNING_getInstance() {
    LogLevel_initEntries();
    return LogLevel_WARNING_instance;
  }
  function LogLevel_ERROR_getInstance() {
    LogLevel_initEntries();
    return LogLevel_ERROR_instance;
  }
  function LogLevel_ASSERT_getInstance() {
    LogLevel_initEntries();
    return LogLevel_ASSERT_instance;
  }
  function Napier() {
    Napier_instance = this;
    this.x5e_1 = AtomicMutableList_init_$Create$();
  }
  protoOf(Napier).y5e = function (antilog) {
    this.x5e_1.a5f(antilog);
  };
  protoOf(Napier).u5e = function (priority, tag) {
    var tmp$ret$0;
    $l$block_0: {
      // Inline function 'kotlin.collections.any' call
      var this_0 = this.x5e_1;
      var tmp;
      if (isInterface(this_0, Collection)) {
        tmp = this_0.d1();
      } else {
        tmp = false;
      }
      if (tmp) {
        tmp$ret$0 = false;
        break $l$block_0;
      }
      var tmp0_iterator = this_0.w();
      while (tmp0_iterator.f()) {
        var element = tmp0_iterator.e();
        // Inline function 'io.github.aakira.napier.Napier.isEnable.<anonymous>' call
        if (element.u5e(priority, tag)) {
          tmp$ret$0 = true;
          break $l$block_0;
        }
      }
      tmp$ret$0 = false;
    }
    return tmp$ret$0;
  };
  protoOf(Napier).v5e = function (priority, tag, throwable, message) {
    // Inline function 'kotlin.collections.forEach' call
    var tmp0_iterator = this.x5e_1.w();
    while (tmp0_iterator.f()) {
      var element = tmp0_iterator.e();
      // Inline function 'io.github.aakira.napier.Napier.rawLog.<anonymous>' call
      element.v5e(priority, tag, throwable, message);
    }
  };
  protoOf(Napier).b5f = function (message, throwable, tag) {
    this.c5f(LogLevel_VERBOSE_getInstance(), tag, throwable, message);
  };
  protoOf(Napier).d5f = function (message, throwable, tag, $super) {
    throwable = throwable === VOID ? null : throwable;
    tag = tag === VOID ? null : tag;
    var tmp;
    if ($super === VOID) {
      this.b5f(message, throwable, tag);
      tmp = Unit_instance;
    } else {
      tmp = $super.b5f.call(this, message, throwable, tag);
    }
    return tmp;
  };
  protoOf(Napier).e5f = function (throwable, tag, message) {
    this.c5f(LogLevel_VERBOSE_getInstance(), tag, throwable, message());
  };
  protoOf(Napier).f5f = function (throwable, tag, message, $super) {
    throwable = throwable === VOID ? null : throwable;
    tag = tag === VOID ? null : tag;
    var tmp;
    if ($super === VOID) {
      this.e5f(throwable, tag, message);
      tmp = Unit_instance;
    } else {
      tmp = $super.e5f.call(this, throwable, tag, message);
    }
    return tmp;
  };
  protoOf(Napier).g5f = function (message, throwable, tag) {
    this.c5f(LogLevel_INFO_getInstance(), tag, throwable, message);
  };
  protoOf(Napier).h5f = function (message, throwable, tag, $super) {
    throwable = throwable === VOID ? null : throwable;
    tag = tag === VOID ? null : tag;
    var tmp;
    if ($super === VOID) {
      this.g5f(message, throwable, tag);
      tmp = Unit_instance;
    } else {
      tmp = $super.g5f.call(this, message, throwable, tag);
    }
    return tmp;
  };
  protoOf(Napier).i5f = function (message, throwable, tag) {
    this.c5f(LogLevel_DEBUG_getInstance(), tag, throwable, message);
  };
  protoOf(Napier).j5f = function (message, throwable, tag, $super) {
    throwable = throwable === VOID ? null : throwable;
    tag = tag === VOID ? null : tag;
    var tmp;
    if ($super === VOID) {
      this.i5f(message, throwable, tag);
      tmp = Unit_instance;
    } else {
      tmp = $super.i5f.call(this, message, throwable, tag);
    }
    return tmp;
  };
  protoOf(Napier).k5f = function (throwable, tag, message) {
    this.c5f(LogLevel_DEBUG_getInstance(), tag, throwable, message());
  };
  protoOf(Napier).l5f = function (throwable, tag, message, $super) {
    throwable = throwable === VOID ? null : throwable;
    tag = tag === VOID ? null : tag;
    var tmp;
    if ($super === VOID) {
      this.k5f(throwable, tag, message);
      tmp = Unit_instance;
    } else {
      tmp = $super.k5f.call(this, throwable, tag, message);
    }
    return tmp;
  };
  protoOf(Napier).m5f = function (message, throwable, tag) {
    this.c5f(LogLevel_WARNING_getInstance(), tag, throwable, message);
  };
  protoOf(Napier).n5f = function (message, throwable, tag, $super) {
    throwable = throwable === VOID ? null : throwable;
    tag = tag === VOID ? null : tag;
    var tmp;
    if ($super === VOID) {
      this.m5f(message, throwable, tag);
      tmp = Unit_instance;
    } else {
      tmp = $super.m5f.call(this, message, throwable, tag);
    }
    return tmp;
  };
  protoOf(Napier).o5f = function (throwable, tag, message) {
    this.c5f(LogLevel_WARNING_getInstance(), tag, throwable, message());
  };
  protoOf(Napier).p5f = function (throwable, tag, message, $super) {
    throwable = throwable === VOID ? null : throwable;
    tag = tag === VOID ? null : tag;
    var tmp;
    if ($super === VOID) {
      this.o5f(throwable, tag, message);
      tmp = Unit_instance;
    } else {
      tmp = $super.o5f.call(this, throwable, tag, message);
    }
    return tmp;
  };
  protoOf(Napier).q5f = function (message, throwable, tag) {
    this.c5f(LogLevel_ERROR_getInstance(), tag, throwable, message);
  };
  protoOf(Napier).r5f = function (message, throwable, tag, $super) {
    throwable = throwable === VOID ? null : throwable;
    tag = tag === VOID ? null : tag;
    var tmp;
    if ($super === VOID) {
      this.q5f(message, throwable, tag);
      tmp = Unit_instance;
    } else {
      tmp = $super.q5f.call(this, message, throwable, tag);
    }
    return tmp;
  };
  protoOf(Napier).s5f = function (throwable, tag, message) {
    this.c5f(LogLevel_ERROR_getInstance(), tag, throwable, message());
  };
  protoOf(Napier).t5f = function (throwable, tag, message, $super) {
    throwable = throwable === VOID ? null : throwable;
    tag = tag === VOID ? null : tag;
    var tmp;
    if ($super === VOID) {
      this.s5f(throwable, tag, message);
      tmp = Unit_instance;
    } else {
      tmp = $super.s5f.call(this, throwable, tag, message);
    }
    return tmp;
  };
  protoOf(Napier).c5f = function (priority, tag, throwable, message) {
    if (this.u5e(priority, tag)) {
      this.v5e(priority, tag, throwable, message);
    }
  };
  var Napier_instance;
  function Napier_getInstance() {
    if (Napier_instance == null)
      new Napier();
    return Napier_instance;
  }
  function AtomicMutableList_init_$Init$($this) {
    // Inline function 'kotlin.collections.listOf' call
    var tmp$ret$0 = emptyList();
    AtomicMutableList.call($this, tmp$ret$0);
    return $this;
  }
  function AtomicMutableList_init_$Create$() {
    return AtomicMutableList_init_$Init$(objectCreate(protoOf(AtomicMutableList)));
  }
  function modify($this, capacityDiff, block) {
    var newValue = ArrayList_init_$Create$($this.u() + capacityDiff | 0);
    newValue.n1($this);
    var result = block(newValue);
    $this.z5e_1.u5f_1 = newValue;
    return result;
  }
  function AtomicMutableList$add$lambda($index, $element) {
    return function ($this$modify) {
      $this$modify.d2($index, $element);
      return Unit_instance;
    };
  }
  function AtomicMutableList(value) {
    AbstractList.call(this);
    this.z5e_1 = new AtomicRef(value);
  }
  protoOf(AtomicMutableList).v5f = function (element, index) {
    return modify(this, 1, AtomicMutableList$add$lambda(index, element));
  };
  protoOf(AtomicMutableList).a5f = function (element, index, $super) {
    var tmp;
    if (index === VOID) {
      // Inline function 'kotlin.collections.count' call
      tmp = this.u();
    } else {
      tmp = index;
    }
    index = tmp;
    var tmp_0;
    if ($super === VOID) {
      this.v5f(element, index);
      tmp_0 = Unit_instance;
    } else {
      tmp_0 = $super.v5f.call(this, element, index);
    }
    return tmp_0;
  };
  protoOf(AtomicMutableList).u = function () {
    return this.z5e_1.u5f_1.u();
  };
  protoOf(AtomicMutableList).d1 = function () {
    return this.z5e_1.u5f_1.d1();
  };
  protoOf(AtomicMutableList).yf = function (element) {
    return this.z5e_1.u5f_1.b1(element);
  };
  protoOf(AtomicMutableList).b1 = function (element) {
    if (!(element == null ? true : !(element == null)))
      return false;
    return this.yf((element == null ? true : !(element == null)) ? element : THROW_CCE());
  };
  protoOf(AtomicMutableList).v = function (index) {
    return this.z5e_1.u5f_1.v(index);
  };
  protoOf(AtomicMutableList).w5f = function (element) {
    return this.z5e_1.u5f_1.x(element);
  };
  protoOf(AtomicMutableList).x = function (element) {
    if (!(element == null ? true : !(element == null)))
      return -1;
    return this.w5f((element == null ? true : !(element == null)) ? element : THROW_CCE());
  };
  protoOf(AtomicMutableList).w = function () {
    return this.z5e_1.u5f_1.w();
  };
  function AtomicRef(value) {
    this.u5f_1 = value;
  }
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = LogLevel_ASSERT_getInstance;
  _.$_$.b = LogLevel_DEBUG_getInstance;
  _.$_$.c = LogLevel_ERROR_getInstance;
  _.$_$.d = LogLevel_INFO_getInstance;
  _.$_$.e = LogLevel_VERBOSE_getInstance;
  _.$_$.f = LogLevel_WARNING_getInstance;
  _.$_$.g = Napier_getInstance;
  _.$_$.h = Antilog;
  //endregion
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js')));

//# sourceMappingURL=Napier-napier-js-ir.js.map
